#include "dxstdafx.h"


#include "CSkinningMethod.h"





CSkinningMethod::CSkinningMethod(LPWSTR filename, DWORD dwFlags, LPWSTR label, LPWSTR description, int MeshID)
{
	wcscpy(m_Filename,filename);
	wcscpy(m_Description,description);
	wcscpy(m_Label,label);
	m_pEffect = NULL;
	m_MeshID = MeshID;
	m_dwFlags = dwFlags;
}


CSkinningMethod::~CSkinningMethod()
{
}


HRESULT CSkinningMethod::OnCreateDevice(IDirect3DDevice9* pd3dDevice, DWORD dwShaderFlags)
{
	HRESULT hr;

	if (!wcscmp(m_Filename,L"")) return S_OK;

	V_RETURN( D3DXCreateEffectFromFile( pd3dDevice, m_Filename, NULL, NULL, dwShaderFlags | m_dwFlags, 
		NULL, &m_pEffect, NULL ) );

	return S_OK;

}

HRESULT CSkinningMethod::OnResetDevice()
{
	if (!wcscmp(m_Filename,L"")) return S_OK;

	return m_pEffect->OnResetDevice();
}


HRESULT CSkinningMethod::OnLostDevice()
{
	if (!wcscmp(m_Filename,L"")) return S_OK;

	return m_pEffect->OnLostDevice();
}


void CSkinningMethod::OnDestroyDevice()
{
	SAFE_RELEASE(m_pEffect);
}




void CSkinningMethod::SetMatViewProj(D3DXMATRIX &matViewProj)
{
	HRESULT hr;

	if (!wcscmp(m_Filename,L"")) return;

	V( m_pEffect->SetMatrix( "mViewProj", &matViewProj ) );
}


void CSkinningMethod::SetLightDir(D3DXVECTOR3 &vLightDir)
{
	HRESULT hr;
	D3DXVECTOR4 vLightDir4( vLightDir.x, vLightDir.y, vLightDir.z,0.0f );

	if (!wcscmp(m_Filename,L"")) return;

	V( m_pEffect->SetVector( "lhtDir", &vLightDir4) );
}