/*! \file 
    \brief Metoda skinningu psana ve vertex shaderu
*/

#pragma once

/// Tda reprezentujc metodu skinningu psanou ve vertex shaderu
class CSkinningMethod
{
public:

	CSkinningMethod(LPWSTR filename, DWORD flags, LPWSTR label, LPWSTR description, int MeshID);
	virtual ~CSkinningMethod();

    /// Reakce na vytvoen D3D zazen
	HRESULT		OnCreateDevice(IDirect3DDevice9* pd3dDevice, DWORD dwShaderFlags);
    /// Reakce na zmnu D3D zazen
	HRESULT		OnResetDevice();
    /// Reakce na zmnu D3D zazen
	HRESULT		OnLostDevice();
    /// Reakce na zruen D3D zazen
	void		OnDestroyDevice();
    /// Nastaven kombinovan pohledov a projekn matice
	void		SetMatViewProj(D3DXMATRIX &matViewProj);
    /// Nastaven zdroje svtla
	void		SetLightDir(D3DXVECTOR3 &dir);
    /// Vrcen popisu metody
	LPWSTR	GetDescription()	{ return m_Description; }
    /// Vrcen nzvu metody
	LPWSTR	GetLabel()			{ return m_Label; }
    /// Vrt identifikaci potebnho modelu pro tuto metodu
	int		GetMeshID()			{ return m_MeshID; }
    /// Vrcen efektu spjatho s metodou
	ID3DXEffect*	GetD3DXEffect() { return m_pEffect; }

	

protected:
	
	WCHAR				m_Filename[100];
	WCHAR				m_Description[100];
	WCHAR				m_Label[100];

	DWORD				m_dwFlags;
	int					m_MeshID;

	IDirect3DDevice9*	m_pd3dDevice;

	// D3DX effect interface
	ID3DXEffect*		m_pEffect;       

	D3DXMATRIX			m_matViewProj;

};