/*! \file 
    \brief Interpolace pomoc RBF
*/ 

#pragma once

#include "CVirtualInterp.h"
#include "matrix.h"

/// Tda reprezentujc interpolaci pomoc radilnch bzovch funkc
class CRBFInterp : public CVirtualInterp
{
public:

	CRBFInterp( INT count, D3DXVECTOR3 *pExamples, FLOAT* pSigmas);
	~CRBFInterp();

	void Interpolate(D3DXVECTOR3 vec, FLOAT* pWeights);
    /// Vzdlenost mezi dvma vektory
	virtual double Length(D3DXVECTOR3 &vec1, D3DXVECTOR3 &vec2);
    /// Vpoet radiln bzov funkce
	virtual double RBF(INT i, double fDist);


protected:

	D3DXVECTOR3		*m_pExamples;
	matrix<double>	*m_pMatrixLambda;
	FLOAT			*m_pSigmas;
	INT				m_iCount;

	
};