/*! \file 
    \brief Struktury vrcholu
*/ 

#pragma once

#include "dxstdafx.h"


/// Struktura vrcholu.
struct VERTEX
{
	/// Souadnice
	D3DXVECTOR3 position;
	// Normala
	D3DXVECTOR3 normal;
};


/// Struktura vrcholu.
struct Blend4TexUnLitVERTEX
{
	/// Souadnice
	D3DXVECTOR3 position;
	/// Blending informace
	FLOAT blend1, blend2, blend3;
	/// Indexy na matice
	DWORD indices;
	/// Normla ve vrcholu
	D3DXVECTOR3 normal;
	/// Souadnice textury
	FLOAT tu, tv;


};



/// Struktura vrcholu.
struct Blend4TexUnLitSBEVERTEX
{
	/// Souadnice
	D3DXVECTOR3 position;
	/// Blending informace
	FLOAT blend1, blend2, blend3;
	/// Indexy na matice
	DWORD indices;
	/// Normla ve vrcholu
	D3DXVECTOR3 normal;
	/// Souadnice textury
	FLOAT tu, tv;
	// Error vektor pro SBE
	D3DXVECTOR3 error;
};



/// Struktura vrcholu.
struct Blend4TexUnLitExpVERTEX
{
	/// Souadnice
	D3DXVECTOR3 position;
	/// Blending informace
	FLOAT blend1, blend2, blend3;
	/// Indexy na matice
	DWORD indices;
	/// Normla ve vrcholu
	D3DXVECTOR3 normal;
	/// Souadnice textury
	FLOAT tu, tv;
	
	D3DXVECTOR4 position1tr;
	D3DXVECTOR3 position2tr;
	D3DXVECTOR3 position3tr;
	D3DXVECTOR3 position4tr;

	D3DXVECTOR3 norm1ofs;
	D3DXVECTOR3 norm2ofs;
	D3DXVECTOR3 norm3ofs;
	D3DXVECTOR3 norm4ofs;


};




/// Struktura vrcholu.
struct Blend4TexUnLitColVERTEX
{
	/// Souadnice
	D3DXVECTOR3 position;
	/// Blending informace
	FLOAT blend1, blend2, blend3;
	/// Indexy na matice
	DWORD indices;
	/// Normla ve vrcholu
	D3DXVECTOR3 normal;
	/// Souadnice textury
	FLOAT tu, tv;
	// barva
	D3DXVECTOR3 color;


};




