#include "dxstdafx.h"

#include "CExpMenu.h"
#include "CExpMesh.h"



void CExpMenu::OnGuiEvent( UINT nEvent, int nControlID, CDXUTControl* pControl )
{
	switch (nControlID)
	{
	case IDC_POSE:
		{
			int iPose = (int)(((CDXUTComboBox*)pControl)->GetSelectedData());
			((CExpMesh*)m_pMesh)->SetPoseToSelectedFrame(iPose);
			break;
		}
	case IDC_HIGHLIGHT_EXVERT:
			((CExpMesh*)m_pMesh)->ShowExampleVertices( ((CDXUTCheckBox*)pControl)->GetChecked());
	}
}

void CExpMenu::InitUserInterface()
{
	int iY = 530;

	m_Dialog.AddCheckBox(IDC_HIGHLIGHT_EXVERT, L"Highlight Example Vertices", -70, iY, 230, 24, false);
	m_Dialog.AddComboBox(IDC_POSE, -70, iY += 30, 230, 24, L'M' );

}


HRESULT CExpMenu::OnResetDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc )
{
	m_Dialog.SetLocation( pBackBufferSurfaceDesc->Width-170, 0 );
	m_Dialog.SetSize( 240, 70 );

	return S_OK;

}


void CExpMenu::SetPoseCount(int iPoseCount)
{
	m_Dialog.GetComboBox( IDC_POSE )->RemoveAllItems();
	m_Dialog.GetComboBox( IDC_POSE )->SetDropHeight(50);

	for (int i=0; i<iPoseCount; ++i)
	{
		WCHAR pom[] = L"Initial Pose";
		if (i!=0) wsprintf(pom,L"Pose %d",i);
		m_Dialog.GetComboBox( IDC_POSE )->AddItem(pom, (void*)(i) );
	}

}

